library plugin;

uses
  ShareMem,
  Windows,
  SysUtils;

type
  TTestArray = array[1..10] of Integer;

procedure TestProc(CharValue : Char;
                   ByteValue : Byte;
                   BooleanValue : Boolean;
                   IntegerValue : Integer; 
                   RealValue : Real; 
                   StringValue : String;
                   VariantValue : Variant;
                   var ArrayValue : TTestArray); stdcall; export;
var
  I : Integer;
  S : String;
begin
  S := 'TestProc:' + #13#10;   
  S := S + 'CharValue=' + CharValue + #13#10;
  S := S + 'ByteValue=' + IntToStr(ByteValue) + #13#10;
  if BooleanValue then
    S := S + 'BooleanValue=true'#13#10          
  else 
    S := S + 'BooleanValue=false'#13#10;          
  S := S + 'IntegerValue=' + IntToStr(IntegerValue) + #13#10;             
  S := S +  'RealValue=' + FloatToStr(RealValue) + #13#10;         
  S := S +  'StringValue=' + StringValue + #13#10;         
  S := S +  'VariantValue=' + VarToStr(VariantValue) + #13#10;          
  S := S +  'ArrayValue='+ #13#10;
  for I:=1 to 10 do 
  begin
    S := S + IntToStr(ArrayValue[I]) + ' ';
    ArrayValue[I] := 10-I+1;
  end;

  MessageBox( GetActiveWindow(), PChar(S), PChar('DLL Message'), MB_ICONEXCLAMATION or MB_OK );
end;

function TestFunc( S : String ) : String; stdcall; export;
begin
  result := S + S;
end;

exports

TestProc, TestFunc;


begin
end.
